#include <stdio.h>
#include <string.h>
#include <mysql.h>
#include "connection.h"
#include "result.h"
#include "row.h"

using namespace std;

char sqlserver[]="pc4466.psi.ch";
char sqluser[]="readonly";
char sqlpasswd[]="readonly";

int main(int argc,char **argv){
  if(argc!=2){
    printf("usage: %s runnumber[7107]\n",argv[0]);
    exit(1);
  }
  
  Connection *connection;
  Result *result;
  Row *row;
  int     run=atoi(argv[1]);
  char    sqlquery[2048];
  int     i;
  int pmtid,adcnum,adcslot,adcchannel,tdcnum,tdccrate,tdcslot,tdcchannel
    ,hvslot,hvchannel,hvnum,hvcable,g10slot,g10channel;
  char geoname[8];
  int nrecord;
  int configuration_id;  
  
  //----------------------------------------
  //Connect to server
  //----------------------------------------
  printf("Connectiong...\n");
  connection = new Connection(sqlserver,"test",sqluser,sqlpasswd);        
  

  //----------------------------------------
  //get configuration ID
  //----------------------------------------

  sprintf(sqlquery,
	  "SELECT configuration_id FROM run WHERE  run.id=%d;"
	  ,run);
  result = connection->Query(sqlquery);
  result->Next();
  row = result->GetCurrentRow();
  configuration_id           = atoi(row->GetField(1));
  

  //----------------------------------------
  //get channel infomations
  //----------------------------------------
  //change database
  connection->Query("USE test;");  
  sprintf(sqlquery,
"SELECT \
   pmt.id,\
   geometry.geometry_name,\
   adc.logical_id,adc.slot,adc.channel,\
   tdc.logical_id,tdc.crate,tdc.slot,tdc.channel,\
   hv.slot,hv.channel, hv.id, hvcable.id, \
   feedthrough.slot,feedthrough.channel \
 FROM \
   adc,burndy,discriminator,feedthrough,geometry,hv,hvcable,pmt,separator,tdc,configuration \
 WHERE \
   configuration.id         = %d and \
   adc.baseid               = configuration.adc_baseid           and \
   burndy.baseid            = configuration.burndy_baseid        and \
   discriminator.baseid     = configuration.discriminator_baseid and \
   feedthrough.baseid       = configuration.feedthrough_baseid   and \
   geometry.baseid          = configuration.geometry_baseid      and \
   hv.baseid                = configuration.hv_baseid            and \
   hvcable.baseid           = configuration.hvcable_baseid       and \
   pmt.baseid               = configuration.pmt_baseid           and \
   separator.baseid         = configuration.separator_baseid     and \
   tdc.baseid               = configuration.tdc_baseid           and \
   geometry.pmt_id          = pmt.id           and \
   geometry.hvcable_id      = hvcable.id       and \
   hvcable.hv_id            = hv.id            and \
   geometry.feedthrough_id  = feedthrough.id   and \
   feedthrough.separator_id = separator.id     and \
   separator.out_id1        = burndy.id        and \
   separator.out_id3        = discriminator.id and \
   burndy.adc_id            = adc.id           and \
   discriminator.tdc_id     = tdc.id \
 ORDER BY \
   adc.logical_id;"
	  , configuration_id

	  ); 
  result = connection->Query(sqlquery);
  nrecord = result->GetRowCount();  
  for(i=0;i<nrecord;i++){
    result->Next();
    row = result->GetCurrentRow();
    
    pmtid      = atoi(row->GetField(1));
    strcpy(geoname,row->GetField(2));
    adcnum     = atoi(row->GetField(3));
    adcslot    = atoi(row->GetField(4));
    adcchannel = atoi(row->GetField(5));
    tdcnum     = atoi(row->GetField(6));
    tdccrate   = atoi(row->GetField(7));
    tdcslot    = atoi(row->GetField(8));
    tdcchannel = atoi(row->GetField(9));
    hvslot     = atoi(row->GetField(10));
    hvchannel  = atoi(row->GetField(11));
    hvnum      = atoi(row->GetField(12));
    hvcable    = atoi(row->GetField(13));
    g10slot    = atoi(row->GetField(14));
    g10channel = atoi(row->GetField(15));
    
    printf("%d\t%s\t%d\t%d-%d\t%d\t%d-%d-%d\t%d-%d\t%d\t%d\t%d-%d\n",
	   pmtid
	   ,geoname
	   ,adcnum,adcslot,adcchannel
	   ,tdcnum,tdccrate,tdcslot,tdcchannel
	   ,hvslot,hvchannel,hvnum,hvcable
	   ,g10slot,g10channel);
  }


  //----------------------------------------
  //disconnect from server
  //---------------------------------------- 
  result->Close();
  delete result;
  connection->Close();
  delete connection;
  printf("Done.\n");
  return 0;
}
